/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2008 by Witz Corporation, JAPAN
 *  Copyright (C) 2010-2014 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEEρE
 *  ĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒쌠
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[X
 *      R[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎgp
 *      ł`ōĔzzꍇɂ́CĔzzɔhLgip҃}
 *      jAȂǁjɁCL̒쌠\C̗pщL̖
 *      ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎgp
 *      łȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNgɕ
 *        邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD܂C
 *      {\tgEFÃ[U܂̓Gh[ÛȂ闝RɊ
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړIɑ΂
 *  K܂߂āCȂۏ؂sȂD܂C{\tgEFA̗p
 *  ɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC
 *  ȂD
 * 
 */

/*
 *		vZbTˑW[iRL78j
 *
 *  ̃CN[ht@ĆC"<vZbT^>_config.h" ݂̂
 *  CN[hD̃t@C璼ڃCN[hĂ͂ȂȂD
 */

#ifndef TOPPERS_PRC_CONFIG_H
#define TOPPERS_PRC_CONFIG_H

/*
 *  (1) ReLXgɊւ`
 */

/* LX^bN̈̂߂̃X^bN|C^l𐶐}N */
#define TOPPERS_ISTKPT(istk, istksz) ((STK_T *)((char *)(istk) + (istksz)))

/*
 *  (2) VXeԂɊւ`
 */

/*
 *  CPUbNԂł̊ݗDx}XN(IPM)̒l
 *    TIPM_LOCḰCCPUbNԂ\銄ݗDx}XN(IPM)̒lD
 *    J[lǗ݂̊ɑ΂銄ݗDx̍ŏl(TMIN_INTPRI)ɓD
 */
#ifndef TIPM_LOCK
#define TIPM_LOCK	TMIN_INTPRI
#endif /* TIPM_LOCK */

/*
 *  ݗDx}XN(IPM) ƃvZbT̊ݗDx}XN(ISP) ̕ϊ
 *
 *  RL78 ł́CPSWWX^̉ʂ琔ărbg1 2  2 rbg
 *  CT[rXEvCIeBEtO(ISP) ̒li[D
 *
 *  J[l̊ǗIPM (-1A̒l) g
 *  vZbT ISP 𐧌䂷邽߂ɕϊKvƂȂD
 *
 *  w肵xȉ݂̊}XNꍇ́CISP̐ݒl
 *  ړĨxDx(lƂĂ͏)lɂKvD
 */
#define IPM2ISP(ipm)	(((uint8_t)(4-1+(ipm))) << 1U)	/* IPM-->ISP(ipm=-3,-2,-1,0) */
#define ISP2IPM(isp)	((PRI)((PRI)(isp >> 1U)+1-4))	/* ISP-->IPM */


/*
 *  ݗDx}XN̓ʂȒlɑ΂\
 */
#define ISP_LOCK	(IPM2ISP(TIPM_LOCK))  	/* CPUbNԂł ISP */
#define ISP_ENAALL	(IPM2ISP(TIPM_ENAALL))	/* TIPM_ENAALL ł ISP */



/*
 *  (3) ݏf(ݗvC)
 */

/*
 * intnoCdis_int^ena_intɑ΂銄ݔԍƂ
 * LȒlłꍇtrueCłȂꍇfalseԂ}N
 */
#define VALID_INTNO_DISINT(intno)	VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(intno)	VALID_INTNO(intno)

/*
 *  IPM 犄ݐ䃌WX^ł̕\ɕϊ}N
 */
#define IPM2ILVL(ipm)	((ipm)+4)	// ipm=-1,-2,-3,-4


/*
 *  (4) ݏf(݃nh)
 */

/*
 *  ݃nh̓̐}N
 */
#define _INT_ENTRY(inhno, inthdr)				_kernel_##inthdr##_##inhno##_entry
#define INT_ENTRY(inhno, inthdr)				_INT_ENTRY(inhno , inthdr)

#define _INTHDR_ENTRY(inhno, inhno_num ,inthdr)	\
		extern _kernel_##inthdr##_##inhno##_entry(void);
#define INTHDR_ENTRY(inhno, inhno_num ,inthdr)	_INTHDR_ENTRY(inhno, inhno_num ,inthdr)

/*
 *  (5) CPUOf
 */

/*
 *  CPUOnh̓̐}N
 */
#define _EXC_ENTRY(excno , exchdr)	_kernel_##exchdr##_##excno##_entry
#define  EXC_ENTRY(excno , exchdr)	_EXC_ENTRY(excno , exchdr)

#define _EXCHDR_ENTRY(excno , excno_num , exchdr) \
	extern _kernel_##exchdr##_##excno##_entry(void);
#define  EXCHDR_ENTRY(excno , excno_num , exchdr)	_EXCHDR_ENTRY(excno , excno_num , exchdr)

/*
 *  (6) EI
 */

// `Ȃ

#ifndef TOPPERS_MACRO_ONLY

/*
 *  (1) ReLXgɊւ`
 */

/*
 *  ReLXg̎Q
 */
extern bool_t sense_context(void);

/*
 *  (2) VXeԂɊւ`
 */

/*
 *  CPUbNtÔ߂̕ϐ (prc_config.c)
 */
extern bool_t	lock_flag;	/* CPUbNtO̒l */
extern uint8_t	saved_psw;	/* CPUbNԈڍsO̊ݗDxx */

/*
 *  CPU bNԂւ̈ڍs
 *      ̊֐́CCPU bNԂ̂ƂɌĂтȂƂOƂD
 */
extern void t_lock_cpu(void);
extern void i_lock_cpu(void);

/*
 *  CPUbNԂ̉
 *      ̊֐́CCPU bNԂ̂Ƃɂ̂݌Ăт邱ƂOƂD
 */
extern void t_unlock_cpu(void);
extern void i_unlock_cpu(void);


/*
 *  CPUbNԂ̎Q
 */
extern bool_t x_sense_lock(void);

#define t_sense_lock()	x_sense_lock()
#define i_sense_lock()	x_sense_lock()

/*
 *  ݗDx}XN(IPM) ̐ݒ
 *    w肵ݗDx(-1, -2, ..., TMIN_INTPRI) 
 *    vZbT̊ݗDxx (IPL) ݒ肷D
 */
extern void x_set_ipm(PRI intpri);

#define t_set_ipm(intpri)	x_set_ipm(intpri)
#define i_set_ipm(intpri)	x_set_ipm(intpri)

extern PRI x_get_ipm(void);

#define i_get_ipm()	x_get_ipm()
#define t_get_ipm()	t_get_ipm()

/*
 *  (3) ݏf(ݗvC)
 */

/*
 *  ݗṽx`e[u (kernel_cfg.c ɂo)
 *    ݔԍ(INTNO) 犄ݗDx擾邽߂ɎgpD
 */
extern const PRI intpri_table[];

/*
 *  ݗv֎~tÕZbg(prc_config.c)
 *    w肵ݔԍɑΉ銄ݗvC̊ݗvtOZbgD
 *    ݑݒ肳ĂȂݗvC̊ݔԍw肵
 *    ꍇ́CP FALSE ԂD
 */
extern bool_t x_disable_int(INTNO intno);

#define t_disable_int(intno)	x_disable_int(intno)
#define i_disable_int(intno)	x_disable_int(intno)

/*
 *  ݗv֎~tÕNA(prc_config.c)
 *    w肵ݔԍɑΉ銄ݗvC̊ݗvtONAD
 *    ݑݒ肳ĂȂݗvC̊ݔԍw肵
 *    ꍇ́CP FALSE ԂD
 */
extern bool_t x_enable_int(INTNO intno);

#define t_enable_int(intno)		x_enable_int(intno)
#define i_enable_int(intno)		x_enable_int(intno)


/*
 *  ݗṽNA(prc_config.c)
 */
extern void x_clear_int(INTNO intno);

#define t_clear_int(intno)		x_clear_int(intno)
#define i_clear_int(intno)		x_clear_int(intno)


/*
 *  ݗṽ`FbN(prc_config.c)
 */
extern bool_t x_probe_int(INTNO intno);

#define t_probe_int(intno)		x_probe_int(intno)
#define i_probe_int(intno)		x_probe_int(intno)

/*
 *  ݗvC̑̐ݒ (prc_config.c)
 */
extern void	x_config_int(INTNO intno, ATR intatr, PRI intpri);

/*
 *  (4) ݏf(݃nh)
 */

/*
 *  ݃nh̐ݒ
 *
 *  RL78ROMɊ݃xN^zu邽߁C{֐͋ɒ`D
 */
#define x_define_inh(inhno, inthdr)

/*
 *  ݃nh̓ŕKvȏ
 */
#define i_begin_int(intno) 		/* ɍsׂ͂Ȃ */

/*
 *  ݃nh̏oŕKvȏ
 */
#define i_end_int(intno)		/* ɍsׂ͂Ȃ */

/*
 *  (5) CPUOf
 */

/*
 *  CPUOnh̐ݒ
 *    RL78  ROM ɃxN^zu邽߁C{֐͋ɒ`D
 */
#define x_define_exc(excno, exchdr)

/*
 *  (6) EI
 */

/*
 *  vZbTˑ̏(prc_config.c)
 */
extern void	prc_initialize(void);

/*
 *  dispatcher ĂяoOɃ^[QbgˑŕKvȏs߂̊֐
 *    (prc_support.asm)
 */
extern void start_dispatch(void);

/*
 *  J[l̏Ǐďoiprc_support.asmj
 *
 *  call_exit_kerneĺCJ[l̏IɌĂяoCX^bN|C^
 *  CJ[l̏Iiexit_kerneljĂяoD
 */
extern void call_exit_kernel(void);

/*
 *  vZbTˑ̏I(prc_config.c)
 */
extern void	prc_terminate(void);

/*
 *  (7) dispacher ł̊ݑ҂
 */
extern void idle_loop(void);


#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_PRC_CONFIG_H */
